diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/model/rate-control/aarf-wifi-manager.cc ns-3.40/src/wifi/model/rate-control/aarf-wifi-manager.cc
--- ns-3.39/src/wifi/model/rate-control/aarf-wifi-manager.cc	2023-07-05 14:23:48.117428300 -0700
+++ ns-3.40/src/wifi/model/rate-control/aarf-wifi-manager.cc	2023-09-27 13:30:37.910839800 -0700
@@ -123,7 +123,7 @@
 AarfWifiManager::DoCreateStation() const
 {
     NS_LOG_FUNCTION(this);
-    AarfWifiRemoteStation* station = new AarfWifiRemoteStation();
+    auto station = new AarfWifiRemoteStation();
 
     station->m_successThreshold = m_minSuccessThreshold;
     station->m_timerTimeout = m_minTimerThreshold;
@@ -157,7 +157,7 @@
 AarfWifiManager::DoReportDataFailed(WifiRemoteStation* st)
 {
     NS_LOG_FUNCTION(this << st);
-    AarfWifiRemoteStation* station = static_cast<AarfWifiRemoteStation*>(st);
+    auto station = static_cast<AarfWifiRemoteStation*>(st);
     station->m_timer++;
     station->m_failed++;
     station->m_success = 0;
@@ -224,7 +224,7 @@
                                 uint8_t dataNss)
 {
     NS_LOG_FUNCTION(this << st << ackSnr << ackMode << dataSnr << dataChannelWidth << +dataNss);
-    AarfWifiRemoteStation* station = static_cast<AarfWifiRemoteStation*>(st);
+    auto station = static_cast<AarfWifiRemoteStation*>(st);
     station->m_timer++;
     station->m_success++;
     station->m_failed = 0;
@@ -259,7 +259,7 @@
 AarfWifiManager::DoGetDataTxVector(WifiRemoteStation* st, uint16_t allowedWidth)
 {
     NS_LOG_FUNCTION(this << st << allowedWidth);
-    AarfWifiRemoteStation* station = static_cast<AarfWifiRemoteStation*>(st);
+    auto station = static_cast<AarfWifiRemoteStation*>(st);
     uint16_t channelWidth = GetChannelWidth(station);
     if (channelWidth > 20 && channelWidth != 22)
     {
@@ -290,7 +290,7 @@
     NS_LOG_FUNCTION(this << st);
     /// \todo we could/should implement the AARF algorithm for
     /// RTS only by picking a single rate within the BasicRateSet.
-    AarfWifiRemoteStation* station = static_cast<AarfWifiRemoteStation*>(st);
+    auto station = static_cast<AarfWifiRemoteStation*>(st);
     uint16_t channelWidth = GetChannelWidth(station);
     if (channelWidth > 20 && channelWidth != 22)
     {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/model/rate-control/amrr-wifi-manager.cc ns-3.40/src/wifi/model/rate-control/amrr-wifi-manager.cc
--- ns-3.39/src/wifi/model/rate-control/amrr-wifi-manager.cc	2023-07-05 14:23:48.117428300 -0700
+++ ns-3.40/src/wifi/model/rate-control/amrr-wifi-manager.cc	2023-09-27 13:30:37.910839800 -0700
@@ -129,7 +129,7 @@
 AmrrWifiManager::DoCreateStation() const
 {
     NS_LOG_FUNCTION(this);
-    AmrrWifiRemoteStation* station = new AmrrWifiRemoteStation();
+    auto station = new AmrrWifiRemoteStation();
     station->m_nextModeUpdate = Simulator::Now() + m_updatePeriod;
     station->m_tx_ok = 0;
     station->m_tx_err = 0;
@@ -158,7 +158,7 @@
 AmrrWifiManager::DoReportDataFailed(WifiRemoteStation* st)
 {
     NS_LOG_FUNCTION(this << st);
-    AmrrWifiRemoteStation* station = static_cast<AmrrWifiRemoteStation*>(st);
+    auto station = static_cast<AmrrWifiRemoteStation*>(st);
     station->m_retry++;
     station->m_tx_retr++;
 }
@@ -181,7 +181,7 @@
                                 uint8_t dataNss)
 {
     NS_LOG_FUNCTION(this << st << ackSnr << ackMode << dataSnr << dataChannelWidth << +dataNss);
-    AmrrWifiRemoteStation* station = static_cast<AmrrWifiRemoteStation*>(st);
+    auto station = static_cast<AmrrWifiRemoteStation*>(st);
     station->m_retry = 0;
     station->m_tx_ok++;
 }
@@ -196,7 +196,7 @@
 AmrrWifiManager::DoReportFinalDataFailed(WifiRemoteStation* st)
 {
     NS_LOG_FUNCTION(this << st);
-    AmrrWifiRemoteStation* station = static_cast<AmrrWifiRemoteStation*>(st);
+    auto station = static_cast<AmrrWifiRemoteStation*>(st);
     station->m_retry = 0;
     station->m_tx_err++;
 }
@@ -334,7 +334,7 @@
 AmrrWifiManager::DoGetDataTxVector(WifiRemoteStation* st, uint16_t allowedWidth)
 {
     NS_LOG_FUNCTION(this << st << allowedWidth);
-    AmrrWifiRemoteStation* station = static_cast<AmrrWifiRemoteStation*>(st);
+    auto station = static_cast<AmrrWifiRemoteStation*>(st);
     UpdateMode(station);
     NS_ASSERT(station->m_txrate < GetNSupported(station));
     uint8_t rateIndex;
@@ -403,7 +403,7 @@
 AmrrWifiManager::DoGetRtsTxVector(WifiRemoteStation* st)
 {
     NS_LOG_FUNCTION(this << st);
-    AmrrWifiRemoteStation* station = static_cast<AmrrWifiRemoteStation*>(st);
+    auto station = static_cast<AmrrWifiRemoteStation*>(st);
     uint16_t channelWidth = GetChannelWidth(station);
     if (channelWidth > 20 && channelWidth != 22)
     {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/model/rate-control/aparf-wifi-manager.cc ns-3.40/src/wifi/model/rate-control/aparf-wifi-manager.cc
--- ns-3.39/src/wifi/model/rate-control/aparf-wifi-manager.cc	2023-07-05 14:23:48.117428300 -0700
+++ ns-3.40/src/wifi/model/rate-control/aparf-wifi-manager.cc	2023-09-27 13:30:37.910839800 -0700
@@ -160,7 +160,7 @@
 AparfWifiManager::DoCreateStation() const
 {
     NS_LOG_FUNCTION(this);
-    AparfWifiRemoteStation* station = new AparfWifiRemoteStation();
+    auto station = new AparfWifiRemoteStation();
 
     station->m_successThreshold = m_successMax1;
     station->m_failThreshold = m_failMax;
@@ -189,7 +189,7 @@
         station->m_critRateIndex = 0;
         WifiMode mode = GetSupported(station, station->m_rateIndex);
         uint16_t channelWidth = GetChannelWidth(station);
-        DataRate rate = DataRate(mode.GetDataRate(channelWidth));
+        DataRate rate(mode.GetDataRate(channelWidth));
         double power = GetPhy()->GetPowerDbm(m_maxPower);
         m_powerChange(power, power, station->m_state->m_address);
         m_rateChange(rate, rate, station->m_state->m_address);
@@ -207,7 +207,7 @@
 AparfWifiManager::DoReportDataFailed(WifiRemoteStation* st)
 {
     NS_LOG_FUNCTION(this << st);
-    AparfWifiRemoteStation* station = static_cast<AparfWifiRemoteStation*>(st);
+    auto station = static_cast<AparfWifiRemoteStation*>(st);
     CheckInit(station);
     station->m_nFailed++;
     station->m_nSuccess = 0;
@@ -271,7 +271,7 @@
                                  uint8_t dataNss)
 {
     NS_LOG_FUNCTION(this << st << ackSnr << ackMode << dataSnr << dataChannelWidth << +dataNss);
-    AparfWifiRemoteStation* station = static_cast<AparfWifiRemoteStation*>(st);
+    auto station = static_cast<AparfWifiRemoteStation*>(st);
     CheckInit(station);
     station->m_nSuccess++;
     station->m_nFailed = 0;
@@ -354,7 +354,7 @@
 AparfWifiManager::DoGetDataTxVector(WifiRemoteStation* st, uint16_t allowedWidth)
 {
     NS_LOG_FUNCTION(this << st << allowedWidth);
-    AparfWifiRemoteStation* station = static_cast<AparfWifiRemoteStation*>(st);
+    auto station = static_cast<AparfWifiRemoteStation*>(st);
     uint16_t channelWidth = GetChannelWidth(station);
     if (channelWidth > 20 && channelWidth != 22)
     {
@@ -362,9 +362,8 @@
     }
     CheckInit(station);
     WifiMode mode = GetSupported(station, station->m_rateIndex);
-    DataRate rate = DataRate(mode.GetDataRate(channelWidth));
-    DataRate prevRate =
-        DataRate(GetSupported(station, station->m_prevRateIndex).GetDataRate(channelWidth));
+    DataRate rate(mode.GetDataRate(channelWidth));
+    DataRate prevRate(GetSupported(station, station->m_prevRateIndex).GetDataRate(channelWidth));
     double power = GetPhy()->GetPowerDbm(station->m_powerLevel);
     double prevPower = GetPhy()->GetPowerDbm(station->m_prevPowerLevel);
     if (station->m_prevPowerLevel != station->m_powerLevel)
@@ -395,7 +394,7 @@
     NS_LOG_FUNCTION(this << st);
     /// \todo we could/should implement the ARF algorithm for
     /// RTS only by picking a single rate within the BasicRateSet.
-    AparfWifiRemoteStation* station = static_cast<AparfWifiRemoteStation*>(st);
+    auto station = static_cast<AparfWifiRemoteStation*>(st);
     uint16_t channelWidth = GetChannelWidth(station);
     if (channelWidth > 20 && channelWidth != 22)
     {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/model/rate-control/arf-wifi-manager.cc ns-3.40/src/wifi/model/rate-control/arf-wifi-manager.cc
--- ns-3.39/src/wifi/model/rate-control/arf-wifi-manager.cc	2023-07-05 14:23:48.117428300 -0700
+++ ns-3.40/src/wifi/model/rate-control/arf-wifi-manager.cc	2023-09-27 13:30:37.910839800 -0700
@@ -107,7 +107,7 @@
 ArfWifiManager::DoCreateStation() const
 {
     NS_LOG_FUNCTION(this);
-    ArfWifiRemoteStation* station = new ArfWifiRemoteStation();
+    auto station = new ArfWifiRemoteStation();
 
     station->m_successThreshold = m_successThreshold;
     station->m_timerTimeout = m_timerThreshold;
@@ -141,7 +141,7 @@
 ArfWifiManager::DoReportDataFailed(WifiRemoteStation* st)
 {
     NS_LOG_FUNCTION(this << st);
-    ArfWifiRemoteStation* station = static_cast<ArfWifiRemoteStation*>(st);
+    auto station = static_cast<ArfWifiRemoteStation*>(st);
     station->m_timer++;
     station->m_failed++;
     station->m_success = 0;
@@ -202,7 +202,7 @@
                                uint8_t dataNss)
 {
     NS_LOG_FUNCTION(this << st << ackSnr << ackMode << dataSnr << dataChannelWidth << +dataNss);
-    ArfWifiRemoteStation* station = static_cast<ArfWifiRemoteStation*>(st);
+    auto station = static_cast<ArfWifiRemoteStation*>(st);
     station->m_timer++;
     station->m_success++;
     station->m_failed = 0;
@@ -236,7 +236,7 @@
 ArfWifiManager::DoGetDataTxVector(WifiRemoteStation* st, uint16_t allowedWidth)
 {
     NS_LOG_FUNCTION(this << st << allowedWidth);
-    ArfWifiRemoteStation* station = static_cast<ArfWifiRemoteStation*>(st);
+    auto station = static_cast<ArfWifiRemoteStation*>(st);
     uint16_t channelWidth = GetChannelWidth(station);
     if (channelWidth > 20 && channelWidth != 22)
     {
@@ -267,7 +267,7 @@
     NS_LOG_FUNCTION(this << st);
     /// \todo we could/should implement the ARF algorithm for
     /// RTS only by picking a single rate within the BasicRateSet.
-    ArfWifiRemoteStation* station = static_cast<ArfWifiRemoteStation*>(st);
+    auto station = static_cast<ArfWifiRemoteStation*>(st);
     uint16_t channelWidth = GetChannelWidth(station);
     if (channelWidth > 20 && channelWidth != 22)
     {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/model/rate-control/cara-wifi-manager.cc ns-3.40/src/wifi/model/rate-control/cara-wifi-manager.cc
--- ns-3.39/src/wifi/model/rate-control/cara-wifi-manager.cc	2023-07-05 14:23:48.117428300 -0700
+++ ns-3.40/src/wifi/model/rate-control/cara-wifi-manager.cc	2023-09-27 13:30:37.910839800 -0700
@@ -115,7 +115,7 @@
 CaraWifiManager::DoCreateStation() const
 {
     NS_LOG_FUNCTION(this);
-    CaraWifiRemoteStation* station = new CaraWifiRemoteStation();
+    auto station = new CaraWifiRemoteStation();
     station->m_rate = 0;
     station->m_success = 0;
     station->m_failed = 0;
@@ -133,7 +133,7 @@
 CaraWifiManager::DoReportDataFailed(WifiRemoteStation* st)
 {
     NS_LOG_FUNCTION(this << st);
-    CaraWifiRemoteStation* station = static_cast<CaraWifiRemoteStation*>(st);
+    auto station = static_cast<CaraWifiRemoteStation*>(st);
     station->m_timer++;
     station->m_failed++;
     station->m_success = 0;
@@ -173,7 +173,7 @@
                                 uint8_t dataNss)
 {
     NS_LOG_FUNCTION(this << st << ackSnr << ackMode << dataSnr << dataChannelWidth << +dataNss);
-    CaraWifiRemoteStation* station = static_cast<CaraWifiRemoteStation*>(st);
+    auto station = static_cast<CaraWifiRemoteStation*>(st);
     station->m_timer++;
     station->m_success++;
     station->m_failed = 0;
@@ -207,7 +207,7 @@
 CaraWifiManager::DoGetDataTxVector(WifiRemoteStation* st, uint16_t allowedWidth)
 {
     NS_LOG_FUNCTION(this << st << allowedWidth);
-    CaraWifiRemoteStation* station = static_cast<CaraWifiRemoteStation*>(st);
+    auto station = static_cast<CaraWifiRemoteStation*>(st);
     uint16_t channelWidth = GetChannelWidth(station);
     if (channelWidth > 20 && channelWidth != 22)
     {
@@ -236,7 +236,7 @@
 CaraWifiManager::DoGetRtsTxVector(WifiRemoteStation* st)
 {
     NS_LOG_FUNCTION(this << st);
-    CaraWifiRemoteStation* station = static_cast<CaraWifiRemoteStation*>(st);
+    auto station = static_cast<CaraWifiRemoteStation*>(st);
     /// \todo we could/should implement the Arf algorithm for
     /// RTS only by picking a single rate within the BasicRateSet.
     uint16_t channelWidth = GetChannelWidth(station);
@@ -269,7 +269,7 @@
 CaraWifiManager::DoNeedRts(WifiRemoteStation* st, uint32_t size, bool normally)
 {
     NS_LOG_FUNCTION(this << st << size << normally);
-    CaraWifiRemoteStation* station = static_cast<CaraWifiRemoteStation*>(st);
+    auto station = static_cast<CaraWifiRemoteStation*>(st);
     return normally || station->m_failed >= m_probeThreshold;
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/model/rate-control/constant-rate-wifi-manager.cc ns-3.40/src/wifi/model/rate-control/constant-rate-wifi-manager.cc
--- ns-3.39/src/wifi/model/rate-control/constant-rate-wifi-manager.cc	2023-07-05 14:23:48.117428300 -0700
+++ ns-3.40/src/wifi/model/rate-control/constant-rate-wifi-manager.cc	2023-09-27 13:30:37.910839800 -0700
@@ -69,7 +69,7 @@
 ConstantRateWifiManager::DoCreateStation() const
 {
     NS_LOG_FUNCTION(this);
-    WifiRemoteStation* station = new WifiRemoteStation();
+    auto station = new WifiRemoteStation();
     return station;
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/model/rate-control/ideal-wifi-manager.cc ns-3.40/src/wifi/model/rate-control/ideal-wifi-manager.cc
--- ns-3.39/src/wifi/model/rate-control/ideal-wifi-manager.cc	2023-07-05 14:23:48.117428300 -0700
+++ ns-3.40/src/wifi/model/rate-control/ideal-wifi-manager.cc	2023-09-27 13:30:37.910839800 -0700
@@ -224,7 +224,7 @@
 IdealWifiManager::DoCreateStation() const
 {
     NS_LOG_FUNCTION(this);
-    IdealWifiRemoteStation* station = new IdealWifiRemoteStation();
+    auto station = new IdealWifiRemoteStation();
     Reset(station);
     return station;
 }
@@ -233,7 +233,7 @@
 IdealWifiManager::Reset(WifiRemoteStation* station) const
 {
     NS_LOG_FUNCTION(this << station);
-    IdealWifiRemoteStation* st = static_cast<IdealWifiRemoteStation*>(station);
+    auto st = static_cast<IdealWifiRemoteStation*>(station);
     st->m_lastSnrObserved = 0.0;
     st->m_lastChannelWidthObserved = 0;
     st->m_lastNssObserved = 1;
@@ -268,7 +268,7 @@
                                 double rtsSnr)
 {
     NS_LOG_FUNCTION(this << st << ctsSnr << ctsMode.GetUniqueName() << rtsSnr);
-    IdealWifiRemoteStation* station = static_cast<IdealWifiRemoteStation*>(st);
+    auto station = static_cast<IdealWifiRemoteStation*>(st);
     station->m_lastSnrObserved = rtsSnr;
     station->m_lastChannelWidthObserved =
         GetPhy()->GetChannelWidth() >= 40 ? 20 : GetPhy()->GetChannelWidth();
@@ -285,7 +285,7 @@
 {
     NS_LOG_FUNCTION(this << st << ackSnr << ackMode.GetUniqueName() << dataSnr << dataChannelWidth
                          << +dataNss);
-    IdealWifiRemoteStation* station = static_cast<IdealWifiRemoteStation*>(st);
+    auto station = static_cast<IdealWifiRemoteStation*>(st);
     if (dataSnr == 0)
     {
         NS_LOG_WARN("DataSnr reported to be zero; not saving this report.");
@@ -307,7 +307,7 @@
 {
     NS_LOG_FUNCTION(this << st << nSuccessfulMpdus << nFailedMpdus << rxSnr << dataSnr
                          << dataChannelWidth << +dataNss);
-    IdealWifiRemoteStation* station = static_cast<IdealWifiRemoteStation*>(st);
+    auto station = static_cast<IdealWifiRemoteStation*>(st);
     if (dataSnr == 0)
     {
         NS_LOG_WARN("DataSnr reported to be zero; not saving this report.");
@@ -336,7 +336,7 @@
 IdealWifiManager::DoGetDataTxVector(WifiRemoteStation* st, uint16_t allowedWidth)
 {
     NS_LOG_FUNCTION(this << st << allowedWidth);
-    IdealWifiRemoteStation* station = static_cast<IdealWifiRemoteStation*>(st);
+    auto station = static_cast<IdealWifiRemoteStation*>(st);
     // We search within the Supported rate set the mode with the
     // highest data rate for which the SNR threshold is smaller than m_lastSnr
     // to ensure correct packet delivery.
@@ -586,7 +586,7 @@
 IdealWifiManager::DoGetRtsTxVector(WifiRemoteStation* st)
 {
     NS_LOG_FUNCTION(this << st);
-    IdealWifiRemoteStation* station = static_cast<IdealWifiRemoteStation*>(st);
+    auto station = static_cast<IdealWifiRemoteStation*>(st);
     // We search within the Basic rate set the mode with the highest
     // SNR threshold possible which is smaller than m_lastSnr to
     // ensure correct packet delivery.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/model/rate-control/minstrel-ht-wifi-manager.cc ns-3.40/src/wifi/model/rate-control/minstrel-ht-wifi-manager.cc
--- ns-3.39/src/wifi/model/rate-control/minstrel-ht-wifi-manager.cc	2023-07-05 14:23:48.117428300 -0700
+++ ns-3.40/src/wifi/model/rate-control/minstrel-ht-wifi-manager.cc	2023-09-27 13:30:37.910839800 -0700
@@ -437,7 +437,7 @@
     txvector.SetGuardInterval(gi);
     txvector.SetChannelWidth(chWidth);
     txvector.SetNess(0);
-    txvector.SetStbc(0);
+    txvector.SetStbc(false);
     txvector.SetMode(mode);
     txvector.SetPreambleType(WIFI_PREAMBLE_HT_MF);
     return WifiPhy::CalculatePhyPreambleAndHeaderDuration(txvector) +
@@ -480,7 +480,7 @@
 MinstrelHtWifiManager::DoCreateStation() const
 {
     NS_LOG_FUNCTION(this);
-    MinstrelHtWifiRemoteStation* station = new MinstrelHtWifiRemoteStation();
+    auto station = new MinstrelHtWifiRemoteStation();
 
     // Initialize variables common to both stations.
     station->m_nextStatsUpdate = Simulator::Now() + m_updateStats;
@@ -572,7 +572,7 @@
 MinstrelHtWifiManager::DoReportRtsFailed(WifiRemoteStation* st)
 {
     NS_LOG_FUNCTION(this << st);
-    MinstrelHtWifiRemoteStation* station = static_cast<MinstrelHtWifiRemoteStation*>(st);
+    auto station = static_cast<MinstrelHtWifiRemoteStation*>(st);
     CheckInit(station);
     if (!station->m_initialized)
     {
@@ -595,7 +595,7 @@
 MinstrelHtWifiManager::DoReportFinalRtsFailed(WifiRemoteStation* st)
 {
     NS_LOG_FUNCTION(this << st);
-    MinstrelHtWifiRemoteStation* station = static_cast<MinstrelHtWifiRemoteStation*>(st);
+    auto station = static_cast<MinstrelHtWifiRemoteStation*>(st);
     NS_LOG_DEBUG("Final RTS failed");
     CheckInit(station);
     if (!station->m_initialized)
@@ -609,7 +609,7 @@
 MinstrelHtWifiManager::DoReportDataFailed(WifiRemoteStation* st)
 {
     NS_LOG_FUNCTION(this << st);
-    MinstrelHtWifiRemoteStation* station = static_cast<MinstrelHtWifiRemoteStation*>(st);
+    auto station = static_cast<MinstrelHtWifiRemoteStation*>(st);
 
     CheckInit(station);
     if (!station->m_initialized)
@@ -644,7 +644,7 @@
                                       uint8_t dataNss)
 {
     NS_LOG_FUNCTION(this << st << ackSnr << ackMode << dataSnr << dataChannelWidth << +dataNss);
-    MinstrelHtWifiRemoteStation* station = static_cast<MinstrelHtWifiRemoteStation*>(st);
+    auto station = static_cast<MinstrelHtWifiRemoteStation*>(st);
 
     CheckInit(station);
     if (!station->m_initialized)
@@ -716,7 +716,7 @@
 MinstrelHtWifiManager::DoReportFinalDataFailed(WifiRemoteStation* st)
 {
     NS_LOG_FUNCTION(this << st);
-    MinstrelHtWifiRemoteStation* station = static_cast<MinstrelHtWifiRemoteStation*>(st);
+    auto station = static_cast<MinstrelHtWifiRemoteStation*>(st);
 
     CheckInit(station);
     if (!station->m_initialized)
@@ -770,7 +770,7 @@
 {
     NS_LOG_FUNCTION(this << st << nSuccessfulMpdus << nFailedMpdus << rxSnr << dataSnr
                          << dataChannelWidth << +dataNss);
-    MinstrelHtWifiRemoteStation* station = static_cast<MinstrelHtWifiRemoteStation*>(st);
+    auto station = static_cast<MinstrelHtWifiRemoteStation*>(st);
 
     CheckInit(station);
     if (!station->m_initialized)
@@ -1023,7 +1023,7 @@
 MinstrelHtWifiManager::DoGetDataTxVector(WifiRemoteStation* st, uint16_t allowedWidth)
 {
     NS_LOG_FUNCTION(this << st << allowedWidth);
-    MinstrelHtWifiRemoteStation* station = static_cast<MinstrelHtWifiRemoteStation*>(st);
+    auto station = static_cast<MinstrelHtWifiRemoteStation*>(st);
 
     if (!station->m_initialized)
     {
@@ -1096,7 +1096,7 @@
 MinstrelHtWifiManager::DoGetRtsTxVector(WifiRemoteStation* st)
 {
     NS_LOG_FUNCTION(this << st);
-    MinstrelHtWifiRemoteStation* station = static_cast<MinstrelHtWifiRemoteStation*>(st);
+    auto station = static_cast<MinstrelHtWifiRemoteStation*>(st);
 
     if (!station->m_initialized)
     {
@@ -1182,7 +1182,7 @@
 {
     NS_LOG_FUNCTION(this << st << packet << normally);
 
-    MinstrelHtWifiRemoteStation* station = static_cast<MinstrelHtWifiRemoteStation*>(st);
+    auto station = static_cast<MinstrelHtWifiRemoteStation*>(st);
 
     CheckInit(station);
     if (!station->m_initialized)
@@ -2229,33 +2229,24 @@
 WifiModeList
 MinstrelHtWifiManager::GetHeDeviceMcsList() const
 {
-    WifiModeList heMcsList;
-    for (const auto& mode : GetPhy()->GetMcsList(WIFI_MOD_CLASS_HE))
-    {
-        heMcsList.push_back(mode);
-    }
+    const auto& mcsList = GetPhy()->GetMcsList(WIFI_MOD_CLASS_HE);
+    WifiModeList heMcsList(mcsList.begin(), mcsList.end());
     return heMcsList;
 }
 
 WifiModeList
 MinstrelHtWifiManager::GetVhtDeviceMcsList() const
 {
-    WifiModeList vhtMcsList;
-    for (const auto& mode : GetPhy()->GetMcsList(WIFI_MOD_CLASS_VHT))
-    {
-        vhtMcsList.push_back(mode);
-    }
+    const auto& mcsList = GetPhy()->GetMcsList(WIFI_MOD_CLASS_VHT);
+    WifiModeList vhtMcsList(mcsList.begin(), mcsList.end());
     return vhtMcsList;
 }
 
 WifiModeList
 MinstrelHtWifiManager::GetHtDeviceMcsList() const
 {
-    WifiModeList htMcsList;
-    for (const auto& mode : GetPhy()->GetMcsList(WIFI_MOD_CLASS_HT))
-    {
-        htMcsList.push_back(mode);
-    }
+    const auto& mcsList = GetPhy()->GetMcsList(WIFI_MOD_CLASS_HT);
+    WifiModeList htMcsList(mcsList.begin(), mcsList.end());
     return htMcsList;
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/model/rate-control/minstrel-wifi-manager.cc ns-3.40/src/wifi/model/rate-control/minstrel-wifi-manager.cc
--- ns-3.39/src/wifi/model/rate-control/minstrel-wifi-manager.cc	2023-07-05 14:23:48.117428300 -0700
+++ ns-3.40/src/wifi/model/rate-control/minstrel-wifi-manager.cc	2023-09-27 13:30:37.910839800 -0700
@@ -178,7 +178,7 @@
 MinstrelWifiManager::DoCreateStation() const
 {
     NS_LOG_FUNCTION(this);
-    MinstrelWifiRemoteStation* station = new MinstrelWifiRemoteStation();
+    auto station = new MinstrelWifiRemoteStation();
 
     station->m_nextStatsUpdate = Simulator::Now() + m_updateStats;
     station->m_col = 0;
@@ -779,7 +779,7 @@
 MinstrelWifiManager::DoReportRtsFailed(WifiRemoteStation* st)
 {
     NS_LOG_FUNCTION(this << st);
-    MinstrelWifiRemoteStation* station = static_cast<MinstrelWifiRemoteStation*>(st);
+    auto station = static_cast<MinstrelWifiRemoteStation*>(st);
     NS_LOG_DEBUG("DoReportRtsFailed m_txrate=" << station->m_txrate);
     station->m_shortRetry++;
 }
@@ -797,7 +797,7 @@
 MinstrelWifiManager::DoReportFinalRtsFailed(WifiRemoteStation* st)
 {
     NS_LOG_FUNCTION(this << st);
-    MinstrelWifiRemoteStation* station = static_cast<MinstrelWifiRemoteStation*>(st);
+    auto station = static_cast<MinstrelWifiRemoteStation*>(st);
     UpdateRetry(station);
 }
 
@@ -805,7 +805,7 @@
 MinstrelWifiManager::DoReportDataFailed(WifiRemoteStation* st)
 {
     NS_LOG_FUNCTION(this << st);
-    MinstrelWifiRemoteStation* station = static_cast<MinstrelWifiRemoteStation*>(st);
+    auto station = static_cast<MinstrelWifiRemoteStation*>(st);
     NS_LOG_DEBUG("DoReportDataFailed " << station << "\t rate " << station->m_txrate
                                        << "\tlongRetry \t" << station->m_longRetry);
     CheckInit(station);
@@ -826,7 +826,7 @@
                                     uint8_t dataNss)
 {
     NS_LOG_FUNCTION(this << st << ackSnr << ackMode << dataSnr << dataChannelWidth << +dataNss);
-    MinstrelWifiRemoteStation* station = static_cast<MinstrelWifiRemoteStation*>(st);
+    auto station = static_cast<MinstrelWifiRemoteStation*>(st);
 
     CheckInit(station);
     if (!station->m_initialized)
@@ -865,7 +865,7 @@
 MinstrelWifiManager::DoReportFinalDataFailed(WifiRemoteStation* st)
 {
     NS_LOG_FUNCTION(this << st);
-    MinstrelWifiRemoteStation* station = static_cast<MinstrelWifiRemoteStation*>(st);
+    auto station = static_cast<MinstrelWifiRemoteStation*>(st);
 
     CheckInit(station);
     if (!station->m_initialized)
@@ -939,7 +939,7 @@
 MinstrelWifiManager::DoGetDataTxVector(WifiRemoteStation* st, uint16_t allowedWidth)
 {
     NS_LOG_FUNCTION(this << st << allowedWidth);
-    MinstrelWifiRemoteStation* station = static_cast<MinstrelWifiRemoteStation*>(st);
+    auto station = static_cast<MinstrelWifiRemoteStation*>(st);
     return GetDataTxVector(station);
 }
 
@@ -947,7 +947,7 @@
 MinstrelWifiManager::DoGetRtsTxVector(WifiRemoteStation* st)
 {
     NS_LOG_FUNCTION(this << st);
-    MinstrelWifiRemoteStation* station = static_cast<MinstrelWifiRemoteStation*>(st);
+    auto station = static_cast<MinstrelWifiRemoteStation*>(st);
     return GetRtsTxVector(station);
 }
 
@@ -957,7 +957,7 @@
                                           bool normally)
 {
     NS_LOG_FUNCTION(this << st << packet << normally);
-    MinstrelWifiRemoteStation* station = static_cast<MinstrelWifiRemoteStation*>(st);
+    auto station = static_cast<MinstrelWifiRemoteStation*>(st);
 
     CheckInit(station);
     if (!station->m_initialized)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/model/rate-control/onoe-wifi-manager.cc ns-3.40/src/wifi/model/rate-control/onoe-wifi-manager.cc
--- ns-3.39/src/wifi/model/rate-control/onoe-wifi-manager.cc	2023-07-05 14:23:48.117428300 -0700
+++ ns-3.40/src/wifi/model/rate-control/onoe-wifi-manager.cc	2023-09-27 13:30:37.910839800 -0700
@@ -115,7 +115,7 @@
 OnoeWifiManager::DoCreateStation() const
 {
     NS_LOG_FUNCTION(this);
-    OnoeWifiRemoteStation* station = new OnoeWifiRemoteStation();
+    auto station = new OnoeWifiRemoteStation();
     station->m_nextModeUpdate = Simulator::Now() + m_updatePeriod;
     station->m_rateBlocked = false;
     station->m_shortRetry = 0;
@@ -138,7 +138,7 @@
 OnoeWifiManager::DoReportRtsFailed(WifiRemoteStation* st)
 {
     NS_LOG_FUNCTION(this << st);
-    OnoeWifiRemoteStation* station = static_cast<OnoeWifiRemoteStation*>(st);
+    auto station = static_cast<OnoeWifiRemoteStation*>(st);
     station->m_shortRetry++;
     station->m_rateBlocked = true; // do not change rate for retransmission
 }
@@ -147,7 +147,7 @@
 OnoeWifiManager::DoReportDataFailed(WifiRemoteStation* st)
 {
     NS_LOG_FUNCTION(this << st);
-    OnoeWifiRemoteStation* station = static_cast<OnoeWifiRemoteStation*>(st);
+    auto station = static_cast<OnoeWifiRemoteStation*>(st);
     station->m_longRetry++;
     station->m_rateBlocked = true; // do not change rate for retransmission
 }
@@ -159,7 +159,7 @@
                                double rtsSnr)
 {
     NS_LOG_FUNCTION(this << st << ctsSnr << ctsMode << rtsSnr);
-    OnoeWifiRemoteStation* station = static_cast<OnoeWifiRemoteStation*>(st);
+    auto station = static_cast<OnoeWifiRemoteStation*>(st);
     station->m_rateBlocked = true; // do not change rate
 }
 
@@ -172,7 +172,7 @@
                                 uint8_t dataNss)
 {
     NS_LOG_FUNCTION(this << st << ackSnr << ackMode << dataSnr << dataChannelWidth << +dataNss);
-    OnoeWifiRemoteStation* station = static_cast<OnoeWifiRemoteStation*>(st);
+    auto station = static_cast<OnoeWifiRemoteStation*>(st);
     UpdateRetry(station);
     station->m_tx_ok++;
     station->m_rateBlocked = false; // we can change the rate for next packet
@@ -182,7 +182,7 @@
 OnoeWifiManager::DoReportFinalRtsFailed(WifiRemoteStation* st)
 {
     NS_LOG_FUNCTION(this << st);
-    OnoeWifiRemoteStation* station = static_cast<OnoeWifiRemoteStation*>(st);
+    auto station = static_cast<OnoeWifiRemoteStation*>(st);
     UpdateRetry(station);
     station->m_tx_err++;
     station->m_rateBlocked = false; // we can change the rate for next packet
@@ -192,7 +192,7 @@
 OnoeWifiManager::DoReportFinalDataFailed(WifiRemoteStation* st)
 {
     NS_LOG_FUNCTION(this << st);
-    OnoeWifiRemoteStation* station = static_cast<OnoeWifiRemoteStation*>(st);
+    auto station = static_cast<OnoeWifiRemoteStation*>(st);
     UpdateRetry(station);
     station->m_tx_err++;
     station->m_rateBlocked = false; // we can change the rate for next packet
@@ -222,9 +222,8 @@
      */
 
     int dir = 0;
-    int enough;
     uint8_t nrate;
-    enough = (station->m_tx_ok + station->m_tx_err >= 10);
+    bool enough = (station->m_tx_ok + station->m_tx_err >= 10);
 
     /* no packet reached -> down */
     if (station->m_tx_err > 0 && station->m_tx_ok == 0)
@@ -294,7 +293,7 @@
 OnoeWifiManager::DoGetDataTxVector(WifiRemoteStation* st, uint16_t allowedWidth)
 {
     NS_LOG_FUNCTION(this << st << allowedWidth);
-    OnoeWifiRemoteStation* station = static_cast<OnoeWifiRemoteStation*>(st);
+    auto station = static_cast<OnoeWifiRemoteStation*>(st);
     UpdateMode(station);
     NS_ASSERT(station->m_txrate < GetNSupported(station));
     uint8_t rateIndex;
@@ -363,7 +362,7 @@
 OnoeWifiManager::DoGetRtsTxVector(WifiRemoteStation* st)
 {
     NS_LOG_FUNCTION(this << st);
-    OnoeWifiRemoteStation* station = static_cast<OnoeWifiRemoteStation*>(st);
+    auto station = static_cast<OnoeWifiRemoteStation*>(st);
     uint16_t channelWidth = GetChannelWidth(station);
     if (channelWidth > 20 && channelWidth != 22)
     {
